Libosmium: osmium::memory::Collection< TMember, TCollectionItemType > Class Template Reference

Libosmium Fast and flexible C++ library for working with OpenStreetMap data

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
osmium::memory::Collection< TMember, TCollectionItemType > Class Template Reference

`#include <collection.hpp>`

Inheritance diagram for osmium::memory::Collection< TMember, TCollectionItemType >:
[legend]
Collaboration diagram for osmium::memory::Collection< TMember, TCollectionItemType >:
[legend]

## Public Types
using | value_type = TMember
using | reference = TMember&
using | const_reference = const TMember&
using | iterator = CollectionIterator<TMember>
using | const_iterator = CollectionIterator<const TMember>
using | size_type = std::size_t

## Public Member Functions
| Collection () noexcept
bool | empty () const noexcept
size_type | size () const noexcept
iterator | begin () noexcept
iterator | end () noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
const_iterator | begin () const noexcept
const_iterator | end () const noexcept
Public Member Functions inherited from osmium::memory::Item
| Item (const Item &)=delete
Item & | operator= (const Item &)=delete
| Item (Item &&)=delete
Item & | operator= (Item &&)=delete
| ~Item () noexcept=default
unsigned char * | next () noexcept
const unsigned char * | next () const noexcept
item_size_type | byte_size () const noexcept
item_size_type | padded_size () const
item_type | type () const noexcept
bool | removed () const noexcept
void | set_removed (const bool removed) noexcept
diff_indicator_type | diff () const noexcept
char | diff_as_char () const noexcept
void | set_diff (const diff_indicator_type diff) noexcept

## Static Public Member Functions
static constexpr bool | is_compatible_to (const osmium::item_type t) noexcept
Static Public Member Functions inherited from osmium::memory::Item
static constexpr bool | is_compatible_to (osmium::item_type) noexcept

## Static Public Attributes
static constexpr osmium::item_type | itemtype = TCollectionItemType

## Additional Inherited Members
Protected Member Functions inherited from osmium::memory::Item
| Item (item_size_type size=0, item_type type=item_type{}) noexcept
Item & | set_type (const item_type item_type) noexcept

## Member Typedef Documentation

## ◆ const_iterator

template<typename TMember, osmium::item_type TCollectionItemType>

using osmium::memory::Collection< TMember, TCollectionItemType >::const_iterator = CollectionIterator<const TMember>

## ◆ const_reference

template<typename TMember, osmium::item_type TCollectionItemType>

using osmium::memory::Collection< TMember, TCollectionItemType >::const_reference = const TMember&

## ◆ iterator

template<typename TMember, osmium::item_type TCollectionItemType>

using osmium::memory::Collection< TMember, TCollectionItemType >::iterator = CollectionIterator<TMember>

## ◆ reference

template<typename TMember, osmium::item_type TCollectionItemType>

using osmium::memory::Collection< TMember, TCollectionItemType >::reference = TMember&

## ◆ size_type

template<typename TMember, osmium::item_type TCollectionItemType>

using osmium::memory::Collection< TMember, TCollectionItemType >::size_type = std::size_t

## ◆ value_type

template<typename TMember, osmium::item_type TCollectionItemType>

using osmium::memory::Collection< TMember, TCollectionItemType >::value_type = TMember

## Constructor & Destructor Documentation

## ◆ Collection()

template<typename TMember, osmium::item_type TCollectionItemType>

osmium::memory::Collection< TMember, TCollectionItemType >::Collection | ( |  | ) |
| inlinenoexcept

## Member Function Documentation

## ◆ begin() [1/2]

template<typename TMember, osmium::item_type TCollectionItemType>

const_iterator osmium::memory::Collection< TMember, TCollectionItemType >::begin | ( |  | ) | const
| inlinenoexcept

## ◆ begin() [2/2]

template<typename TMember, osmium::item_type TCollectionItemType>

iterator osmium::memory::Collection< TMember, TCollectionItemType >::begin | ( |  | ) |
| inlinenoexcept

## ◆ cbegin()

template<typename TMember, osmium::item_type TCollectionItemType>

const_iterator osmium::memory::Collection< TMember, TCollectionItemType >::cbegin | ( |  | ) | const
| inlinenoexcept

## ◆ cend()

template<typename TMember, osmium::item_type TCollectionItemType>

const_iterator osmium::memory::Collection< TMember, TCollectionItemType >::cend | ( |  | ) | const
| inlinenoexcept

## ◆ empty()

template<typename TMember, osmium::item_type TCollectionItemType>

bool osmium::memory::Collection< TMember, TCollectionItemType >::empty | ( |  | ) | const
| inlinenoexcept

Does this collection contain any items?

Complexity: Constant.

## ◆ end() [1/2]

template<typename TMember, osmium::item_type TCollectionItemType>

const_iterator osmium::memory::Collection< TMember, TCollectionItemType >::end | ( |  | ) | const
| inlinenoexcept

## ◆ end() [2/2]

template<typename TMember, osmium::item_type TCollectionItemType>

iterator osmium::memory::Collection< TMember, TCollectionItemType >::end | ( |  | ) |
| inlinenoexcept

## ◆ is_compatible_to()

template<typename TMember, osmium::item_type TCollectionItemType>

constexpr bool osmium::memory::Collection< TMember, TCollectionItemType >::is_compatible_to | ( | const osmium::item_type | t | ) |
| inlinestaticconstexprnoexcept

## ◆ size()

template<typename TMember, osmium::item_type TCollectionItemType>

size_type osmium::memory::Collection< TMember, TCollectionItemType >::size | ( |  | ) | const
| inlinenoexcept

Returns the number of items in this collection.

Complexity: Linear in the number of items.

## Member Data Documentation

## ◆ itemtype

template<typename TMember, osmium::item_type TCollectionItemType>

osmium::item_type osmium::memory::Collection< TMember, TCollectionItemType >::itemtype = TCollectionItemType
| staticconstexpr

The documentation for this class was generated from the following file:

- include/osmium/memory/collection.hpp